udevcontrol reload_rules >/dev/null 2>&1 || true
echo -n " udev"
-# install grub loader
-if ! grub-install --no-floppy '(hd0)' >/dev/null 2>&1; then
+# update device map if possible
+device_map=/boot/grub/device.map
+if [ -f $device_map ]; then
+ mv -f $device_map $device_map.old
+fi
+grub --batch --no-floppy --device-map=$device_map <<EOF >/dev/null 2>&1
+quit
+EOF
+if [ ! -s $device_map ]; then
+ if [ -f $device_map.old ]; then
+ mv -f $device_map.old $device_map
+ fi
+else
+ rm -f $device_map.old
+fi
+echo -n " grub4"
+
+# install GRUB loader
+install_device=$(grep '^(hd0)' $device_map | \
+ sed -e 's%[^[:space:]]*[[:space:]]*\([^[:space:]]*\)%\1%')
+if [ -z "$install_device" ]; then
echo "."
- echo "CN: FATAL ERROR running grub-install!"
+ echo "CN: FATAL ERROR while detecting boot disk!"
echo "CN: Do not reboot your server and report this to OTRS immediately!"
exit 1
fi
-echo -n " grub4"
+if ! grub-install --no-floppy "$install_device" >/dev/null 2>&1; then
+ echo "."
+ echo "CN: FATAL ERROR while running grub-install!"
+ echo "CN: Do not reboot your server and report this to OTRS immediately!"
+ exit 1
+fi
+echo -n " grub5"
# fix possible wrong params in menu.lst
cp_check_and_sed '^# groot=' \
"s;^# kopt=\(.*\)root=[^[:space:]]*\(.*\);# kopt=\1root=$root_device\2;g" \
/boot/grub/menu.lst || true
/usr/sbin/update-grub >/dev/null 2>&1 || true
-echo -n " grub5"
+echo -n " grub6"
# restore execshield state
if [ ! -z "$SHIELD" ]; then